#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

int find(char* toFind, char* inTxt);
int len(char* txt);
char compare(char* subTxt, char*Txt);
void replace(char* toFind, char* toReplace, char*inTxt);

/****************************************
* @brief: main Funktion, die verschiedene 
* Routinen zu suchen/ersetzen testet
****************************************/
int main(int argc, char **argv)
{
	char text[1000];
	printf("Compare(\"text\",\"text\")=%d\n",compare("text","text"));

	printf("Gefunden an Position %d\n",find("Text","Dies ist ein Text!"));

	sprintf(text,"Dies ist ein Text!");
	replace("ist","war",text);
	printf("%s\n",text);
	return 0;
}
/**************************************
* @brief: returns the negth of a cstring
***************************************/
int len(char* txt)
{
	int length;
	for (length=0; txt[length]!=0; length++){
	}
	return length;
}
/**************************************
* comares 2 strings and returns TRUE if
* they are identical
***************************************/
char compare(char* subTxt, char* txt)
{
	int length,t;
	
	length = len(subTxt);
	for (t=0; t<length; t++){
		if (subTxt[t] != txt[t]){
			return FALSE;
		}
	}
	return TRUE;
}
/**************************************
* @brief: finds a string in another string
***************************************/
int find(char* toFind, char* inTxt)
{
 	int lenToFind = len(toFind);
	int lenInTxt  = len(inTxt);
	int t;

	for (t=0; t< lenInTxt-lenToFind; t++){
		if (compare(&toFind[0],&inTxt[t]) == TRUE){
			return t;
		}
	}
	return -1;
}
/**************************************
* @brief: deletes the string beginning
* at pos with num chars long
***************************************/
void shiftTextToLeft(char* inTxt, int pos, int num)
{
	int t;
	for (t=pos; inTxt[t+num]!=0; t++){
		inTxt[t] = inTxt[t+num];
	}
	inTxt[t] = inTxt[t+num]; // copy NULL
}
/**************************************
* shifts the text to the right to have
* a gap for the replace text
***************************************/
void shiftTextToRight(char* inTxt, int pos, int num)
{
	int end=len(inTxt);
	int t;
	for (t = end; t>=pos; t--){
		inTxt[t+num] = inTxt[t];
	}
}
/**************************************
* @brief: replaces a  toFind string in 
* inText by toReplace
***************************************/
void replace(char* toFind, char* toReplace, char*inTxt)
{
 int pos = find(toFind, inTxt);
 int lenToReplace = len(toReplace);
 int t;

 if (pos>=0){
	 shiftTextToLeft(inTxt,pos,len(toFind));
	 shiftTextToRight(inTxt,pos,len(toReplace));
	 for (t=pos;t<pos+lenToReplace; t++){
		 inTxt[t] = toReplace[t-pos];
	 }
 }
}
